SystemOrganization addCategory: #PacMan!

TestCase subclass: #PacManTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!PacManTest methodsFor: 'actors' stamp: 'AgustinMosteiro 4/29/2013 20:09'!
blueGhost

	^Ghost new! !

!PacManTest methodsFor: 'actors' stamp: 'AgustinMosteiro 4/29/2013 20:15'!
blueberry

	^Fruit new! !

!PacManTest methodsFor: 'movements' stamp: 'AgustinMosteiro 4/29/2013 21:17'!
down

	^0 @ -1! !

!PacManTest methodsFor: 'construction block types' stamp: 'AgustinMosteiro 4/29/2013 21:23'!
ghostHouseDoorType

	^GhostHouseDoor new! !

!PacManTest methodsFor: 'movements' stamp: 'AgustinMosteiro 4/29/2013 21:16'!
left

	 ^-1 @ 0! !

!PacManTest methodsFor: 'construction block types' stamp: 'AgustinMosteiro 5/3/2013 19:38'!
leftTransporterType

	^LeftTransporter new! !

!PacManTest methodsFor: 'actors' stamp: 'AgustinMosteiro 4/29/2013 20:12'!
pacman

	^Pacman new! !

!PacManTest methodsFor: 'movements' stamp: 'AgustinMosteiro 4/29/2013 21:16'!
right

	^1 @ 0! !

!PacManTest methodsFor: 'construction block types' stamp: 'AgustinMosteiro 4/29/2013 20:22'!
spaceType

	^Space new
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:31'!
test01GhostCanNotGoIntoAWall

	self assert: self blueGhost position equals: ( self wallType nextPositionFor: self blueGhost going: self left ).
	self assert: self blueGhost position equals: ( self wallType nextPositionFor: self blueGhost going: self right ).
	self assert: self blueGhost position equals: ( self wallType nextPositionFor: self blueGhost going: self up ).
	self assert: self blueGhost position equals: ( self wallType nextPositionFor: self blueGhost going: self down ).
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:31'!
test02PacmanCanNotGoIntoAWall

	self assert: self pacman position equals: ( self wallType nextPositionFor: self pacman going: self left ).
	self assert: self pacman position equals: ( self wallType nextPositionFor: self pacman going: self right ).
	self assert: self pacman position equals: ( self wallType nextPositionFor: self pacman going: self up ).
	self assert: self pacman position equals: ( self wallType nextPositionFor: self pacman going: self down ).
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:38'!
test02aFruitCanNotGoIntoAWall

	self assert: self blueberry position equals: ( self wallType nextPositionFor: self blueberry going: self left ).
	self assert: self blueberry position equals: ( self wallType nextPositionFor: self blueberry going: self right ).
	self assert: self blueberry position equals: ( self wallType nextPositionFor: self blueberry going: self up ).
	self assert: self blueberry position equals: ( self wallType nextPositionFor: self blueberry going: self down ).
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:31'!
test03GhostMovesIntoSpaces

	self assert: ( self blueGhost position + (-1@0) ) equals: ( self spaceType nextPositionFor: self blueGhost going: self left ).
	self assert: ( self blueGhost position +  (1@0) ) equals: ( self spaceType nextPositionFor: self blueGhost going: self right ).
	self assert: ( self blueGhost position +  (0@1) ) equals: ( self spaceType nextPositionFor: self blueGhost going: self up ).
	self assert: ( self blueGhost position + (0@ -1) ) equals: ( self spaceType nextPositionFor: self blueGhost going: self down ).
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:31'!
test04PacmanMovesIntoSpaces

	self assert: ( self pacman position + (-1@0) ) equals: ( self spaceType nextPositionFor: self pacman going: self left ).
	self assert: ( self pacman position +  (1@0) ) equals: ( self spaceType nextPositionFor: self pacman going: self right ).
	self assert: ( self pacman position +  (0@1) ) equals: ( self spaceType nextPositionFor: self pacman going: self up ).
	self assert: ( self pacman position + (0@ -1) ) equals: ( self spaceType nextPositionFor: self pacman going: self down ).

! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:39'!
test04aFruitMovesIntoSpaces

	self assert: ( self blueberry position + (-1@0) ) equals: ( self spaceType nextPositionFor: self blueberry going: self left ).
	self assert: ( self blueberry position +  (1@0) ) equals: ( self spaceType nextPositionFor: self blueberry going: self right ).
	self assert: ( self blueberry position +  (0@1) ) equals: ( self spaceType nextPositionFor: self blueberry going: self up ).
	self assert: ( self blueberry position + (0@ -1) ) equals: ( self spaceType nextPositionFor: self blueberry going: self down ).

! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:30'!
test05GhostCanEnterHisHouse

	self assert: ( self blueGhost position + (-1@0) ) equals: (self ghostHouseDoorType nextPositionFor: self blueGhost going: self left).
	self assert: ( self blueGhost position +  (1@0) ) equals: (self ghostHouseDoorType nextPositionFor: self blueGhost going: self right ).
	self assert: ( self blueGhost position +  (0@1) ) equals: (self ghostHouseDoorType nextPositionFor: self blueGhost going: self up ).
	self assert: ( self blueGhost position + (0@ -1) ) equals: (self ghostHouseDoorType nextPositionFor: self blueGhost going: self down ).
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:30'!
test06PacmanCanNotEnterGhostHouse

	self assert: self pacman position equals: ( self ghostHouseDoorType nextPositionFor: self pacman going: self left ).
	self assert: self pacman position equals: ( self ghostHouseDoorType nextPositionFor: self pacman going: self right ).
	self assert: self pacman position equals: ( self ghostHouseDoorType nextPositionFor: self pacman going: self up ).
	self assert: self pacman position equals: ( self ghostHouseDoorType nextPositionFor: self pacman going: self down ).
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:40'!
test06aFruitCanEnterHisHouse

	self assert: ( self blueberry position + (-1@0) ) equals: (self ghostHouseDoorType nextPositionFor: self blueberry going: self left).
	self assert: ( self blueberry position +  (1@0) ) equals: (self ghostHouseDoorType nextPositionFor: self blueberry going: self right ).
	self assert: ( self blueberry position +  (0@1) ) equals: (self ghostHouseDoorType nextPositionFor: self blueberry going: self up ).
	self assert: ( self blueberry position + (0@ -1) ) equals: (self ghostHouseDoorType nextPositionFor: self blueberry going: self down ).
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:30'!
test07GhostCanNotGoIntoTransporter

	self assert: self blueGhost position equals: ( self leftTransporterType nextPositionFor: self blueGhost going: self left ).
	self assert: self blueGhost position equals: ( self leftTransporterType nextPositionFor: self blueGhost going: self right ).
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:30'!
test08TransporterMovesPacmanToNewPosition

	self assert: (3@10) equals: ( self leftTransporterType nextPositionFor: self pacman going: self left ).
	self assert: (3@10) equals: ( self leftTransporterType nextPositionFor: self pacman going: self right ).
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:46'!
test09TransporterMovesFruitToNewPosition

	self assert: (5@10) equals: ( self leftTransporterType nextPositionFor: self blueberry going: self left ).
	self assert: (5@10) equals: ( self leftTransporterType nextPositionFor: self blueberry going: self right ).
! !

!PacManTest methodsFor: 'movements' stamp: 'AgustinMosteiro 4/29/2013 21:17'!
up

	^0 @ 1! !

!PacManTest methodsFor: 'construction block types' stamp: 'AgustinMosteiro 4/29/2013 20:09'!
wallType

	^Wall new! !

Object subclass: #Actor
	instanceVariableNames: 'position'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!Actor methodsFor: 'as yet unclassified' stamp: 'AgustinMosteiro 5/3/2013 19:35'!
nextPositionWhenMovingInto: aGhostHouseDoor going: aDirection

	self shouldBeImplemented! !

!Actor methodsFor: 'as yet unclassified' stamp: 'AgustinMosteiro 5/3/2013 19:47'!
position

	^position! !

Actor subclass: #Fruit
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!Fruit methodsFor: 'as yet unclassified' stamp: 'AgustinMosteiro 4/29/2013 21:19'!
initialize

	position := 0 @ 0! !

!Fruit methodsFor: 'as yet unclassified' stamp: 'AgustinMosteiro 5/3/2013 19:55'!
nextPositionWhenMovingInto: aBlock going: aDirection
"Fruits can't decide if they can move into a block so they ask to it"

	^aBlock nextPositionForTheFruit: self going: aDirection! !

Actor subclass: #Ghost
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!Ghost methodsFor: 'as yet unclassified' stamp: 'AgustinMosteiro 4/29/2013 21:18'!
initialize

	position := 0 @ 0! !

!Ghost methodsFor: 'as yet unclassified' stamp: 'AgustinMosteiro 5/3/2013 19:43'!
nextPositionWhenMovingInto: aBlock going: aDirection
"Ghosts can't decide if they can move into a block so they ask to it"

	^aBlock nextPositionForTheGhost: self going: aDirection! !

Actor subclass: #Pacman
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!Pacman methodsFor: 'as yet unclassified' stamp: 'AgustinMosteiro 4/29/2013 21:19'!
initialize

	position := 0 @ 0! !

!Pacman methodsFor: 'as yet unclassified' stamp: 'AgustinMosteiro 5/3/2013 19:55'!
nextPositionWhenMovingInto: aBlock going: aDirection
"Pacman can't decide if it can move into a block so they ask to it"

	^aBlock nextPositionForThePacman: self going: aDirection! !

Object subclass: #Block
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!Block methodsFor: 'as yet unclassified' stamp: 'AgustinMosteiro 4/29/2013 20:34'!
nextPositionFor: aGhost going: aDirection

	self shouldBeImplemented! !

Block subclass: #GhostHouseDoor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!GhostHouseDoor methodsFor: 'as yet unclassified' stamp: 'AgustinMosteiro 5/3/2013 19:41'!
nextPositionFor: anActor going: aDirection
"Ghost house doors ask actors if they can move into"

	^anActor nextPositionWhenMovingInto: self going: aDirection! !

!GhostHouseDoor methodsFor: 'as yet unclassified' stamp: 'AgustinMosteiro 5/3/2013 19:34'!
nextPositionForTheFruit: aFruit going: aDirection 
"Ghost house doors allow fruits to move"

	^aFruit position + aDirection! !

!GhostHouseDoor methodsFor: 'as yet unclassified' stamp: 'AgustinMosteiro 5/3/2013 19:27'!
nextPositionForTheGhost: aGhost going: aDirection
"Ghost house doors allow ghosts to move"

	^aGhost position + aDirection! !

!GhostHouseDoor methodsFor: 'as yet unclassified' stamp: 'AgustinMosteiro 5/3/2013 19:27'!
nextPositionForThePacman: aPacman going: aDirection
"Ghost house doors don't allow pacman to move into"

	^aPacman position! !

Block subclass: #LeftTransporter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!LeftTransporter methodsFor: 'as yet unclassified' stamp: 'AgustinMosteiro 5/3/2013 19:41'!
nextPositionFor: anActor going: aDirection
"Left transporters ask actors if they can move into"

	^anActor nextPositionWhenMovingInto: self going: aDirection! !

!LeftTransporter methodsFor: 'as yet unclassified' stamp: 'AgustinMosteiro 5/3/2013 19:57'!
nextPositionForTheFruit: aFruit going: aDirection
"Left transporters move fruits to 5 @ 10"

	^5 @ 10! !

!LeftTransporter methodsFor: 'as yet unclassified' stamp: 'AgustinMosteiro 5/3/2013 19:52'!
nextPositionForTheGhost: aGhost going: aDirection
"Left transporters don't allow ghosts to move"

	^aGhost position! !

!LeftTransporter methodsFor: 'as yet unclassified' stamp: 'AgustinMosteiro 5/3/2013 19:56'!
nextPositionForThePacman: aPacman going: aDirection
"Left transporters move pacman to 3 @ 10"

	^3 @ 10! !

Block subclass: #Space
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!Space methodsFor: 'as yet unclassified' stamp: 'AgustinMosteiro 5/3/2013 19:23'!
nextPositionFor: anActor going: aDirection
"Spaces always allow actors to move"

	^anActor position + aDirection! !

Block subclass: #Wall
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!Wall methodsFor: 'as yet unclassified' stamp: 'AgustinMosteiro 5/3/2013 19:24'!
nextPositionFor: anActor going: aDirection
"Walls don't allow actors to move"

	^anActor position! !
